std::is_swappable_with,std::is_swappable,std::is_nothrow_swappable_with,(3)

NAME
std::is_swappable_with,std::is_swappable,std::is_nothrow_swappable_with, - std::is_swappable_with,std::is_swappable,std::is_nothrow_swappable_with,

Synopsis
   Defined in header <type_traits>
   template< class T, class U > (1) (since C++17)
   struct is_swappable_with;
   template< class T > (2) (since C++17)
   struct is_swappable;
   template< class T, class U > (3) (since C++17)
   struct is_nothrow_swappable_with;
   template< class T > (4) (since C++17)
   struct is_nothrow_swappable;
   1) If the expressions swap(std::declval<T>(), std::declval<U>()) and
   swap(std::declval<U>(), std::declval<T>()) are both well-formed in unevaluated
   context after using std::swap; (see Swappable), provides the member constant value
   equal true. Otherwise, value is false. Access checks are performed as if from a
   context unrelated to either type.
   2) If T is not a referenceable type (i.e., possibly cv-qualified void or a function
   type with a cv-qualifier-seq or a ref-qualifier), provides a member constant value
   equal to false. Otherwise, provides a member constant value equal to
   std::is_swappable_with<T&, T&>::value
   3) Same as (1), but evaluations of both expressions from (1) are known not to throw
   exceptions
   4) Same as (2), but uses is_nothrow_swappable_with.
   T and U shall each be a complete type, (possibly cv-qualified) void, or an array of
   unknown bound. Otherwise, the behavior is undefined.
   If an instantiation of a template above depends, directly or indirectly, on an
   incomplete type, and that instantiation could yield a different result if that type
   were hypothetically completed, the behavior is undefined.
   The behavior of a program that adds specializations for any of the templates
   described on this page is undefined.
  Helper variable templates
   template <class T, class U>
   inline constexpr bool is_swappable_with_v = is_swappable_with<T, (since C++17)
   U>::value;
   template <class T> (since C++17)
   inline constexpr bool is_swappable_v = is_swappable<T>::value;
   template <class T, class U>
   inline constexpr bool is_nothrow_swappable_with_v = (since C++17)
   is_nothrow_swappable_with<T, U>::value;
   template <class T>
   inline constexpr bool is_nothrow_swappable_v = (since C++17)
   is_nothrow_swappable<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is swappable with U , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Notes
   This trait does not check anything outside the immediate context of the swap
   expressions: if the use of T or U would trigger template specializations, generation
   of implicitly-defined special member functions etc, and those have errors, the
   actual swap may not compile even if std::is_swappable_with<T,U>::value compiles and
   evaluates to true.

Example
    This section is incomplete
    Reason: no example

See also
   swap swaps the values of two objects
                        (function template)
   is_move_assignable
   is_trivially_move_assignable
   is_nothrow_move_assignable checks if a type has a move assignment operator
   (C++11) (class template)
   (C++11)
   (C++11)
   swappable specifies that a type can be swapped or that two types
   swappable_with can be swapped with each other
   (C++20) (concept)